#include <stdio.h>
#include <assert.h>
#include <string.h>
#include "SndfileWavUtil.h"

const  int Taps = 9;
static int newest;
static short int x[Taps] = {0,0,0,0,0,0,0,0,0};
static short int fir(short int);
const  int short_sz = sizeof(short);

// lifted from the bluespec code
static double h[Taps] =  {-0.0124,
			  0.0,
			  -0.0133,
			  0.0,
			  0.8181,
			  0.0,
			  -0.0133,
			  0.0,
			  -0.0124};


int
main (int argc, char * argv [])
{
  const char* inputWavFileName;
  const char* outputWavFileName;

  FILE *inputPcmFile;
  FILE *outputPcmFile;

  short int sample;

  inputWavFileName = argv[1];
  outputWavFileName = argv[2];

  // Convert input wav to pcm
  generate_pcm(inputWavFileName, "input.pcm");

  inputPcmFile = fopen("input.pcm", "r");
  outputPcmFile = fopen("output.pcm", "w");

  assert(inputPcmFile);
  assert(outputPcmFile);

  newest = 0;
  memset(x, 0, sizeof(x));

  while(fread(&sample, short_sz, 1, inputPcmFile)) {
    sample = fir(sample);
    assert(fwrite(&sample,short_sz,1,outputPcmFile));
  } 

  fclose(inputPcmFile);
  fclose(outputPcmFile);

  generate_wav("output.pcm", inputWavFileName, outputWavFileName);
}

short int
fir(short int sample)
{

  x[newest] = sample; 
  double y = 0;

  for (int k = 0; k < Taps; k++) { 

    short int bits = x[(newest+k)%Taps];
    double x = (double)bits;
    y += h[k] * x; 

  }

  newest = (newest == 0) ? (Taps-1) : (newest-1);

  short int rv = ((short int)y)&0x0000FFFF;
  return rv;
}

